//
//  CSSLineHeightDialog.java
//  JHime
//
//  Created by 山下 弘隆 on 08/04/26.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

import javax.swing.ButtonGroup;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;

import javax.swing.border.LineBorder;

public class CSSLineHeightDialog extends HTMLDialog {
	private JRadioButton normalBtn	= new JRadioButton("normal", true);
	private JRadioButton lengthBtn	= new JRadioButton("数値・長さ・%値");
	private JRadioButton inheritBtn	= new JRadioButton("inherit");

	private JTextField lengthField	= new JTextField(10);
	private String[] length_str = {
		"", "%", "em", "ex", "px", "in", "cm", "mm", "pt", "pc"
	};
	private JComboBox lengthBox		= new JComboBox(length_str);

	public CSSLineHeightDialog (TextView view) {
		super(view);
		setDialog(view, "line-heightプロパティ", 100, 100);
	}

	protected JPanel createHTMLDocumentPanel() {
		ButtonGroup btnGroup = new ButtonGroup();
		btnGroup.add(normalBtn);
		btnGroup.add(lengthBtn);
		btnGroup.add(inheritBtn);

		GridBagLayout layout = new GridBagLayout();
		GridBagConstraints gc = new GridBagConstraints();
		JPanel pane = new JPanel(layout);

		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = new Insets(5,5,5,5);
		gc.gridwidth = 1;
		gc.gridheight = 1;

		gridLayoutComponent(pane, layout, gc, normalBtn,	0, 0, true);
		gridLayoutComponent(pane, layout, gc, lengthBtn,	0, 1, true);
		gridLayoutComponent(pane, layout, gc, lengthField,	1, 1, false);
		gridLayoutComponent(pane, layout, gc, lengthBox,	2, 1, false);
		gridLayoutComponent(pane, layout, gc, inheritBtn,	0, 2, true);

		lengthBtn.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e) {
				enabledSetting(e, lengthBox);
				enabledSetting(e, lengthField);
			}
		});

		return pane;
	}


	public String getString() {
		StringBuffer buff = new StringBuffer();

		for (int i = 0; i < JHime.CSS_TAB_COUNT; i++) {
			buff.append("\t");
		}
		buff.append("line-height: ");
		if (lengthBtn.isSelected()) {
			buff.append(lengthField.getText());
			buff.append(lengthBox.getSelectedItem());
		} else if (normalBtn.isSelected()) {
			buff.append("normal");
		} else {
			buff.append("inherit");
		}
		buff.append(";\n");

		return buff.toString();
	}
}